package cnf;
import cnf.Bool;

public class Literal {
	private int id;
	private boolean neg;
	
	/**
	 * Creates a new literal (unnegated)
	 * @param newID
	 */
	public Literal(int newID)
	{
		id = newID;
		neg = false;
	}
	
	/**
	 * Adds a ~ to the front of the given literal
	 */
	public void negate()
	{
		if(!neg)
			neg = true;
		else
			neg = false;
	}
	
	/**
	 * Returns the literal's ID for use in environmental assignment
	 */
	public int getID()
	{
		return(id);
	}
	
	/**
	 * Returns the literals negation
	 */
	
	public boolean getNeg()
	{
		return(neg);
	}
	
	/**
	 * Prints the literal
	 */
	public void print()
	{
		if(neg)
			System.err.print("~");
		System.err.print("<");
		System.err.print(id);
		System.err.print(">");
	}
	
	/**
	 * Processes any negation in evaluating the literal
	 * @param value - assigned value (by environment)
	 * @return true value (i.e. value *-1 iff neg)
	 */
	public Bool eval(Bool value)
	{
		if(!neg || value == Bool.UNDEFINED)
			return(value);
		else if(value == Bool.TRUE)
			return(Bool.FALSE);
		else
			return(Bool.TRUE);
	}
}
