package arithmetic;

import arithmetic.*;

public class EvaluateVisitor implements ExprVisitor<Double> {
	
	Double value = new Double(0);
	
	@Override
	public Double visit(Const c)
	{
		value = new Double(c.value);
		return(value);
	}
	
	@Override
	public Double visit(Plus plus)
	{
		plus.left.accept(this);
		Double leftVal = value;
		plus.right.accept(this);
		Double rightVal = value;
		value = new Double(leftVal.doubleValue() + rightVal.doubleValue());
		return(value);
	}

	@Override
	public Double visit(Minus minus)
	{
		minus.left.accept(this);
		Double leftVal = value;
		minus.right.accept(this);
		Double rightVal = value;
		value = new Double(leftVal.doubleValue() - rightVal.doubleValue());
		return(value);
	}

	@Override
	public Double visit(Mult mult)
	{
		mult.left.accept(this);
		Double leftVal = value;
		mult.right.accept(this);
		Double rightVal = value;
		value = new Double(leftVal.doubleValue() * rightVal.doubleValue());
		return(value);
	}
	
	@Override
	public Double visit(Div div)
	{
		div.left.accept(this);
		Double leftVal = value;
		div.right.accept(this);
		Double rightVal = value;
		value = new Double(leftVal.doubleValue() / rightVal.doubleValue());
		return(value);
	}	
}
