package arithmetic;

import arithmetic.*;

public class SignVisitor implements ExprVisitor<Sign> {
	
	Sign sign = Sign.UNKNOWN;
	
	@Override
	public Sign visit(Const c)
	{
		if(c.value >= 0)
			sign = Sign.POSITIVE;
		else
			sign = Sign.NEGATIVE;
		return(sign);
	}
	
	@Override
	public Sign visit(Plus plus)
	{
		plus.left.accept(this);
		Sign leftSign = sign;
		plus.right.accept(this);
		Sign rightSign = sign;
		if(leftSign == Sign.NEGATIVE && rightSign == Sign.NEGATIVE)
			sign = Sign.NEGATIVE;
		else if(leftSign == Sign.POSITIVE && rightSign == Sign.POSITIVE)
			sign = Sign.POSITIVE;
		else
			sign = Sign.UNKNOWN;
		return(sign);
	}
	
	@Override
	public Sign visit(Minus minus)
	{
		minus.left.accept(this);
		Sign leftSign = sign;
		minus.right.accept(this);
		Sign rightSign = sign;
		if(leftSign == Sign.NEGATIVE && rightSign == Sign.POSITIVE)
			sign = Sign.NEGATIVE;
		else if(leftSign == Sign.POSITIVE && rightSign == Sign.NEGATIVE)
			sign = Sign.POSITIVE;
		else
			sign = Sign.UNKNOWN;
		return(sign);
	}
	
	@Override
	public Sign visit(Mult mult)
	{
		mult.left.accept(this);
		Sign leftSign = sign;
		mult.right.accept(this);
		Sign rightSign = sign;
		if(leftSign == rightSign)
			sign = Sign.POSITIVE;
		else
			sign = Sign.NEGATIVE;
		return(sign);
	}	
	
	@Override
	public Sign visit(Div div)
	{
		div.left.accept(this);
		Sign leftSign = sign;
		div.right.accept(this);
		Sign rightSign = sign;
		if(leftSign == rightSign)
			sign = Sign.POSITIVE;
		else
			sign = Sign.NEGATIVE;
		return(sign);
	}	
}
