package multipart;

import java.io.IOException;
import java.io.InputStream;
import multipart.Download;
/**
 * 
 * Download machine implements Download. This implements the downloader
 * which reads ahead one byte and saves the result in currByte. 
 * @author scottyoung
 *
 */
public class DownloadMachine implements Download {

	public static final int REQUEST_STREAM = -1;
	private int currByte = REQUEST_STREAM;
	private InputStream stream = null;
	
	public void add(InputStream in)
	{
		stream = in;
	}
	
	/**
	 * Returns the last byte read
	 */
	public int readByte()
	{
		try
		{
			currByte = stream.read();
		}catch(IOException e){
			System.err.println("Error reading byte in DownloadMachine--"+e.getMessage());
		}
		return(currByte);
	}
}
