package abc;

import java.util.regex.*;

public class Fraction {
	
	public static double parseFraction(String f)
	{
		double num, den;
		if(f.matches("\\s*"))
			return(1.0);
		else if(f.matches("[0-9]+"))
			return((double)Integer.parseInt(f));
		else if(f.matches("[0-9]*/[0-9]*"))
		{
			String[] parts = f.split("/");
			if(f.matches("/[0-9]*"))
				num = 1;
			else
				num = (double)Integer.parseInt(parts[0]);
			if(f.matches("[0-9]*/"))
				den = 2;			
			else
				den = (double)Integer.parseInt(parts[1]);
			
			return (num / den);
		}
		else
		{
			System.err.println("Warning, "+f+" is not a fraction!");
			return(1.0);
		}
	}
}
