package music;

import music.*;
import java.util.ArrayList;

public class Section implements MusicElement{

	public ArrayList<Bar> bars;
	public boolean repeat = false;
	
	public Section()
	{
		bars = new ArrayList<Bar>();
	}
	
	public Bar newBar()
	{
		Bar bar = new Bar();
		bars.add(bar);
		return(bar);
	}
	
	public boolean verify(double meter)
	{
		for(Bar b : bars)
		{
			if(!b.verify(meter))
				return false;
		}
		return true;
	}
	
	public void print()
	{
		System.err.print("SECTION:");
		if(repeat) System.err.print("x2\n"); else System.err.print("\n");
		for(Bar b : bars)
		{
			b.print();
			System.err.print(" | ");
		}
		System.err.print("\n");
	}

	@Override
	public void accept(MusicVisitor v)
	{
		v.visit(this);
	}
	
}
