package music;

import music.*;
import java.util.ArrayList;
import java.lang.String;

public class Voice implements MusicElement{
	
	String name;
	public ArrayList<Section> sections;
	
	public Voice(String theName)
	{
		name = theName;
		sections = new ArrayList<Section>();
	}
	
	public Section newSection()
	{
		Section section = new Section();
		sections.add(section);
		return(section);
	}
	
	public boolean verify(double meter)
	{
		for(Section s: sections)
		{
			if(!s.verify(meter))
				return false;
		}
		return true;
	}	
	
	public void print()
	{
		System.err.println("V: "+name);
		for(Section s: sections)
		{
			s.print();
		}
	}
	
	public void accept(MusicVisitor v)
	{
		v.visit(this);
	}
}
